duplicateTab.contextMenu =
{
  // ID's of the context menu items used by Duplicate Tab
  IDS:
  {
    MENU_ITEM_IDS: ['duptab-separator', 'duplicate-tab-menu', 'duptab-new-tab', 'duptab-new-window', 'duptab-detach-tab', 'duptab-merge-window'],
    TAB_MENU_ITEM_IDS: ['tab-duptab-separator', 'tab-duplicate-tab-menu', 'tab-duptab-new-tab', 'tab-duptab-new-window', 'tab-duptab-detach-tab', 'tab-duptab-merge-window'],
    SUB_MENU_MENU_ITEM_IDS: ['duplicate-tab-new-tab', 'duplicate-tab-new-window', 'duplicate-tab-detach-tab', 'duplicate-tab-merge-windows']  
  },

  // add contextmenuitems to tab
  addTabContextMenu: function()
  {
    var tabbarContextMenu = getBrowser().mStrip.childNodes[1];

    for (var i=5; i>=0; i--) {
      var newItem = document.getElementById(this.IDS.MENU_ITEM_IDS[i]).cloneNode(true);
      newItem.setAttribute('id', this.IDS.TAB_MENU_ITEM_IDS[i]);
      tabbarContextMenu.insertBefore(newItem, tabbarContextMenu.childNodes[5]);
    }
    this.setPlaceTabContextMenuItems();

    document.getElementById('contentAreaContextMenu').addEventListener("popupshowing", this.contentContextShow, false);
    document.getElementById('contentAreaContextMenu').addEventListener("popuphiding", this.contextHide, false);
    tabbarContextMenu.addEventListener("popupshowing", this.tabContextShow, false);
    tabbarContextMenu.addEventListener("popuphiding", this.contextHide, false);
  },

  deinit: function()
  {
    document.getElementById('contentAreaContextMenu').removeEventListener("popupshowing", this.contentContextShow, false);
    document.getElementById('contentAreaContextMenu').removeEventListener("popuphiding", this.contextHide, false);

    var tabbarContextMenu = getBrowser().mStrip.childNodes[1];
    tabbarContextMenu.removeEventListener("popupshowing", this.tabContextShow, false);
    tabbarContextMenu.removeEventListener("popuphiding", this.contextHide, false);
  },

  positionListener:
  {
    observe: function(subject, topic, prefName)
    {
      if (topic != "nsPref:changed")
        return;
      duplicateTab.contextMenu.setPlaceTabContextMenuItems();
    }
  },

  setPlaceTabContextMenuItems: function()
  {
    var menuPosition = duplicateTab.getPreference("duplicatetab.contextMenuItems.position", 5);
    var tabbarContextMenu = getBrowser().mStrip.childNodes[1];
    var menuItems = new Array();
    var dtMenuItems = tabbarContextMenu.getElementsByAttribute('duplicatetab', 'true');

    var i, j = 5;
    for (i=5; i>=0; i--) {
      menuItem = dtMenuItems[i];
      if ((menuItem.nodeName == 'menuitem') || (menuItem.nodeName == 'menu')) {
        menuItems[j] = tabbarContextMenu.removeChild(menuItem);
        j--;
      }
      else if (menuItem.nodeName == 'menuseparator')
        menuItems[0] = tabbarContextMenu.removeChild(menuItem);
    }

    if (menuPosition > tabbarContextMenu.childNodes.length-1) {
      for (i=5; i>=0; i--) {
        tabbarContextMenu.appendChild(menuItems[i]);
      }
      return;
    }

    if (((menuPosition == 0) || ((menuPosition > 0) && (tabbarContextMenu.childNodes[menuPosition-1].localName != 'menuitem'))) && (tabbarContextMenu.childNodes[menuPosition].localName == 'menuitem'))
      tabbarContextMenu.insertBefore(menuItems[0], tabbarContextMenu.childNodes[menuPosition]);

    for (i=5; i>=1; i--) {
      tabbarContextMenu.insertBefore(menuItems[i], tabbarContextMenu.childNodes[menuPosition]);
    }
    if ((menuPosition > 0) && (tabbarContextMenu.childNodes[menuPosition-1].localName == 'menuitem'))
      tabbarContextMenu.insertBefore(menuItems[i], tabbarContextMenu.childNodes[menuPosition]);
  },

  // only show the menuitems the user wishes to see
  showMenuItems: function(where, hideMenu)
  {
    var i, contextObj, menuitemids, subMenuPref;

    function hideAllItems()
    {
      for (i = 0; i < 6; i++) {
        contextObj.getElementsByAttribute('id', menuitemids[i])[0].hidden = true;
      }
    }

    function hideSomeItems()
    {
      var whichMenuItems = duplicateTab.getPreference("duplicatetab.showContextMenu.items", "3333");
      if (whichMenuItems.length == 3) {
        whichMenuItems = whichMenuItems.substr(0,2) + "3" + whichMenuItems.substr(-1);
      }
      var dtItems;
      if (contextObj == document)
        dtItems = [Boolean(parseInt(whichMenuItems.charAt(0))>1),
                   Boolean(parseInt(whichMenuItems.charAt(1))>1),
                   Boolean(parseInt(whichMenuItems.charAt(2))>1),
                   Boolean(parseInt(whichMenuItems.charAt(3))>1)];
      else
        dtItems = [Boolean(parseInt(whichMenuItems.charAt(0))%2),
                   Boolean(parseInt(whichMenuItems.charAt(1))%2),
                   Boolean(parseInt(whichMenuItems.charAt(2))%2),
                   Boolean(parseInt(whichMenuItems.charAt(3))%2)];

      contextObj.getElementsByAttribute('id', menuitemids[0])[0].hidden = hideMenu;
      if (subMenuPref) {
        contextObj.getElementsByAttribute('id', menuitemids[1])[0].hidden = hideMenu;
        for (i = 0; i < subMenuitemids.length; i++) {
          if (dtItems[i])
            contextObj.getElementsByAttribute('id', subMenuitemids[i])[0].hidden = hideMenu;
          else
            contextObj.getElementsByAttribute('id', subMenuitemids[i])[0].hidden = true;
        }
        for (i = 2; i < 6; i++) {
          contextObj.getElementsByAttribute('id', menuitemids[i])[0].hidden = true;
        }
      }
      else {
        contextObj.getElementsByAttribute('id', menuitemids[1])[0].hidden = true;
        for (i = 0; i < 4; i++) {
          if (dtItems[i])
            contextObj.getElementsByAttribute('id', menuitemids[i+2])[0].hidden = hideMenu;
          else
            contextObj.getElementsByAttribute('id', menuitemids[i+2])[0].hidden = true;
        }
      }
    }

    var subMenuitemids = this.IDS.SUB_MENU_MENU_ITEM_IDS;
    switch (where)
    {
      // when the context menu of a tab is requested
      case 'tab':
        contextObj = getBrowser().mStrip.childNodes[1];
        menuitemids = this.IDS.TAB_MENU_ITEM_IDS;
        subMenuPref = duplicateTab.getPreference("duplicatetab.showContextMenu.inSubMenu", true);
        var inTabContext = duplicateTab.getPreference("duplicatetab.showContextMenu.onTab", true);
        if (!inTabContext) {
          hideAllItems();
          break;
        }
        else if (inTabContext) {
          hideSomeItems();
          break;
        }

      // when the context menu of a page is requested
      case 'content':
        contextObj = document;
        menuitemids = this.IDS.MENU_ITEM_IDS;
        subMenuPref = duplicateTab.getPreference("duplicatetab.showContextMenu.inContentSubMenu", true);
        var inPageContext = duplicateTab.getPreference("duplicatetab.showContextMenu.onContentArea", false);
        if (!inPageContext){
          hideAllItems();
          break;
        }
        else if (inPageContext) {
          hideSomeItems();
          break;
        }
    }
  },

  // set which context menu items to show and where
  contentContextShow: function()
  {
    var hiddenMenu = (gContextMenu.isTextSelected || gContextMenu.onTextInput);
    document.getElementById('duptab-open-link').hidden = !(gContextMenu.onSaveableLink || (gContextMenu.inDirList && gContextMenu.onLink));

    duplicateTab.contextMenu.showMenuItems('content', hiddenMenu);

    return;
  },

  tabContextShow: function()
  {
    var popupNodeName = document.popupNode.localName;
    var duptabitems = getBrowser().mStrip.childNodes[1].getElementsByAttribute("duplicatetab", "true");

    // show menuitems alone in tabs context menu, not in the context menu of the tabbar
    if (popupNodeName != 'tab') {
      for (var i=0;i<duptabitems.length;i++) {
        duptabitems.item(i).hidden = true;
      }
    }

    // Hide the menuitems the user doesn't want to show
    else if (popupNodeName == 'tab')
      duplicateTab.contextMenu.showMenuItems('tab', false);
  },

  contextHide: function()
  {
    // nothing here at the moment
  }
}
